/*
 * File         : BV_AppReadThread.C
 * Author       : Tomasz Stachowiak
 * Created      : Fri Jul 24 16:33:30 1998
 * Revision     : $Revision$
 * Updated      : $Date$
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/socket.h>
#define _BSD_SIGNALS
#include <signal.h>
#include <netdb.h>
#include <netinet/in.h>

#include "BV_AppReadThread.h"
#include "BV_Application.h"
#include "rtp.h"

BV_AppReadThread::BV_AppReadThread(void *app)
{
  app_ = app;
}

int BV_AppReadThread::run()
{
  struct timeval timeout;
  fd_set set;
  RTPheader *header;
  char *msg;
  int size;
  int sockfd;
  char *data;
  struct sockaddr_in addr;
  int len;

  sockfd = ((BV_Application *)app_)->get_data_sock();
  while(running)
    {
      timeout.tv_sec = 0;
      timeout.tv_usec = 10000;
      FD_ZERO(&set);
      FD_SET(sockfd, &set);

      if(select(sockfd + 1, &set, 0, 0, &timeout) > 0)
	{
	  if(FD_ISSET(sockfd, &set))
	    {
	      data = new char[MAX_UDP_SIZE];
	      size = recvfrom(sockfd, data, MAX_UDP_SIZE, 0, &addr, &len);
	      if(size > 0)
		{
		  size = size - sizeof(RTPheader);
		  header = (RTPheader *)data;
		  msg = data + sizeof(RTPheader);
		  /*printf("Get data type %d from user %d\n", header->pt, header->ssrc);*/
		  ((BV_Application *)app_)->process_message(header, msg, size);
		}
	      else
		return -1;
	      
	      delete data;
	    }
	}
    }

  return 0;
}
